<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfParaBirimi ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfParaBirimi
 * @subpackage Arrays
 */
class ArrayOfParaBirimi extends AbstractStructArrayBase
{
    /**
     * The ParaBirimi
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ParaBirimi[]
     */
    public $ParaBirimi;
    /**
     * Constructor method for ArrayOfParaBirimi
     * @uses ArrayOfParaBirimi::setParaBirimi()
     * @param \StructType\ParaBirimi[] $paraBirimi
     */
    public function __construct(array $paraBirimi = array())
    {
        $this
            ->setParaBirimi($paraBirimi);
    }
    /**
     * Get ParaBirimi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ParaBirimi[]|null
     */
    public function getParaBirimi()
    {
        return isset($this->ParaBirimi) ? $this->ParaBirimi : null;
    }
    /**
     * This method is responsible for validating the values passed to the setParaBirimi method
     * This method is willingly generated in order to preserve the one-line inline validation within the setParaBirimi method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateParaBirimiForArrayConstraintsFromSetParaBirimi(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfParaBirimiParaBirimiItem) {
            // validation for constraint: itemType
            if (!$arrayOfParaBirimiParaBirimiItem instanceof \StructType\ParaBirimi) {
                $invalidValues[] = is_object($arrayOfParaBirimiParaBirimiItem) ? get_class($arrayOfParaBirimiParaBirimiItem) : sprintf('%s(%s)', gettype($arrayOfParaBirimiParaBirimiItem), var_export($arrayOfParaBirimiParaBirimiItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ParaBirimi property can only contain items of type \StructType\ParaBirimi, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ParaBirimi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ParaBirimi[] $paraBirimi
     * @return \ArrayType\ArrayOfParaBirimi
     */
    public function setParaBirimi(array $paraBirimi = array())
    {
        // validation for constraint: array
        if ('' !== ($paraBirimiArrayErrorMessage = self::validateParaBirimiForArrayConstraintsFromSetParaBirimi($paraBirimi))) {
            throw new \InvalidArgumentException($paraBirimiArrayErrorMessage, __LINE__);
        }
        if (is_null($paraBirimi) || (is_array($paraBirimi) && empty($paraBirimi))) {
            unset($this->ParaBirimi);
        } else {
            $this->ParaBirimi = $paraBirimi;
        }
        return $this;
    }
    /**
     * Add item to ParaBirimi value
     * @throws \InvalidArgumentException
     * @param \StructType\ParaBirimi $item
     * @return \ArrayType\ArrayOfParaBirimi
     */
    public function addToParaBirimi(\StructType\ParaBirimi $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ParaBirimi) {
            throw new \InvalidArgumentException(sprintf('The ParaBirimi property can only contain items of type \StructType\ParaBirimi, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ParaBirimi[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ParaBirimi|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ParaBirimi|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ParaBirimi|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ParaBirimi|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ParaBirimi|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ParaBirimi
     */
    public function getAttributeName()
    {
        return 'ParaBirimi';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfParaBirimi
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
