<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUrunDetayTab ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUrunDetayTab
 * @subpackage Arrays
 */
class ArrayOfUrunDetayTab extends AbstractStructArrayBase
{
    /**
     * The UrunDetayTab
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UrunDetayTab[]
     */
    public $UrunDetayTab;
    /**
     * Constructor method for ArrayOfUrunDetayTab
     * @uses ArrayOfUrunDetayTab::setUrunDetayTab()
     * @param \StructType\UrunDetayTab[] $urunDetayTab
     */
    public function __construct(array $urunDetayTab = array())
    {
        $this
            ->setUrunDetayTab($urunDetayTab);
    }
    /**
     * Get UrunDetayTab value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UrunDetayTab[]|null
     */
    public function getUrunDetayTab()
    {
        return isset($this->UrunDetayTab) ? $this->UrunDetayTab : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUrunDetayTab method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUrunDetayTab method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUrunDetayTabForArrayConstraintsFromSetUrunDetayTab(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUrunDetayTabUrunDetayTabItem) {
            // validation for constraint: itemType
            if (!$arrayOfUrunDetayTabUrunDetayTabItem instanceof \StructType\UrunDetayTab) {
                $invalidValues[] = is_object($arrayOfUrunDetayTabUrunDetayTabItem) ? get_class($arrayOfUrunDetayTabUrunDetayTabItem) : sprintf('%s(%s)', gettype($arrayOfUrunDetayTabUrunDetayTabItem), var_export($arrayOfUrunDetayTabUrunDetayTabItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UrunDetayTab property can only contain items of type \StructType\UrunDetayTab, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UrunDetayTab value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UrunDetayTab[] $urunDetayTab
     * @return \ArrayType\ArrayOfUrunDetayTab
     */
    public function setUrunDetayTab(array $urunDetayTab = array())
    {
        // validation for constraint: array
        if ('' !== ($urunDetayTabArrayErrorMessage = self::validateUrunDetayTabForArrayConstraintsFromSetUrunDetayTab($urunDetayTab))) {
            throw new \InvalidArgumentException($urunDetayTabArrayErrorMessage, __LINE__);
        }
        if (is_null($urunDetayTab) || (is_array($urunDetayTab) && empty($urunDetayTab))) {
            unset($this->UrunDetayTab);
        } else {
            $this->UrunDetayTab = $urunDetayTab;
        }
        return $this;
    }
    /**
     * Add item to UrunDetayTab value
     * @throws \InvalidArgumentException
     * @param \StructType\UrunDetayTab $item
     * @return \ArrayType\ArrayOfUrunDetayTab
     */
    public function addToUrunDetayTab(\StructType\UrunDetayTab $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UrunDetayTab) {
            throw new \InvalidArgumentException(sprintf('The UrunDetayTab property can only contain items of type \StructType\UrunDetayTab, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UrunDetayTab[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UrunDetayTab|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UrunDetayTab|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UrunDetayTab|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UrunDetayTab|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UrunDetayTab|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UrunDetayTab
     */
    public function getAttributeName()
    {
        return 'UrunDetayTab';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfUrunDetayTab
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
