<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUrunResim ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUrunResim
 * @subpackage Arrays
 */
class ArrayOfUrunResim extends AbstractStructArrayBase
{
    /**
     * The UrunResim
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UrunResim[]
     */
    public $UrunResim;
    /**
     * Constructor method for ArrayOfUrunResim
     * @uses ArrayOfUrunResim::setUrunResim()
     * @param \StructType\UrunResim[] $urunResim
     */
    public function __construct(array $urunResim = array())
    {
        $this
            ->setUrunResim($urunResim);
    }
    /**
     * Get UrunResim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UrunResim[]|null
     */
    public function getUrunResim()
    {
        return isset($this->UrunResim) ? $this->UrunResim : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUrunResim method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUrunResim method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUrunResimForArrayConstraintsFromSetUrunResim(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUrunResimUrunResimItem) {
            // validation for constraint: itemType
            if (!$arrayOfUrunResimUrunResimItem instanceof \StructType\UrunResim) {
                $invalidValues[] = is_object($arrayOfUrunResimUrunResimItem) ? get_class($arrayOfUrunResimUrunResimItem) : sprintf('%s(%s)', gettype($arrayOfUrunResimUrunResimItem), var_export($arrayOfUrunResimUrunResimItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UrunResim property can only contain items of type \StructType\UrunResim, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UrunResim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UrunResim[] $urunResim
     * @return \ArrayType\ArrayOfUrunResim
     */
    public function setUrunResim(array $urunResim = array())
    {
        // validation for constraint: array
        if ('' !== ($urunResimArrayErrorMessage = self::validateUrunResimForArrayConstraintsFromSetUrunResim($urunResim))) {
            throw new \InvalidArgumentException($urunResimArrayErrorMessage, __LINE__);
        }
        if (is_null($urunResim) || (is_array($urunResim) && empty($urunResim))) {
            unset($this->UrunResim);
        } else {
            $this->UrunResim = $urunResim;
        }
        return $this;
    }
    /**
     * Add item to UrunResim value
     * @throws \InvalidArgumentException
     * @param \StructType\UrunResim $item
     * @return \ArrayType\ArrayOfUrunResim
     */
    public function addToUrunResim(\StructType\UrunResim $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UrunResim) {
            throw new \InvalidArgumentException(sprintf('The UrunResim property can only contain items of type \StructType\UrunResim, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UrunResim[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UrunResim|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UrunResim|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UrunResim|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UrunResim|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UrunResim|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UrunResim
     */
    public function getAttributeName()
    {
        return 'UrunResim';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfUrunResim
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
