<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KategoriDil StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:KategoriDil
 * @subpackage Structs
 */
class KategoriDil extends AbstractStructBase
{
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ID;
    /**
     * The Icerik
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Icerik;
    /**
     * The SeoAnahtarKelime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SeoAnahtarKelime;
    /**
     * The SeoSayfaAciklama
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SeoSayfaAciklama;
    /**
     * The SeoSayfaBaslik
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SeoSayfaBaslik;
    /**
     * The Tanim
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Tanim;
    /**
     * Constructor method for KategoriDil
     * @uses KategoriDil::setID()
     * @uses KategoriDil::setIcerik()
     * @uses KategoriDil::setSeoAnahtarKelime()
     * @uses KategoriDil::setSeoSayfaAciklama()
     * @uses KategoriDil::setSeoSayfaBaslik()
     * @uses KategoriDil::setTanim()
     * @param int $iD
     * @param string $icerik
     * @param string $seoAnahtarKelime
     * @param string $seoSayfaAciklama
     * @param string $seoSayfaBaslik
     * @param string $tanim
     */
    public function __construct($iD = null, $icerik = null, $seoAnahtarKelime = null, $seoSayfaAciklama = null, $seoSayfaBaslik = null, $tanim = null)
    {
        $this
            ->setID($iD)
            ->setIcerik($icerik)
            ->setSeoAnahtarKelime($seoAnahtarKelime)
            ->setSeoSayfaAciklama($seoSayfaAciklama)
            ->setSeoSayfaBaslik($seoSayfaBaslik)
            ->setTanim($tanim);
    }
    /**
     * Get ID value
     * @return int|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\KategoriDil
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !(is_int($iD) || ctype_digit($iD))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Icerik value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIcerik()
    {
        return isset($this->Icerik) ? $this->Icerik : null;
    }
    /**
     * Set Icerik value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $icerik
     * @return \StructType\KategoriDil
     */
    public function setIcerik($icerik = null)
    {
        // validation for constraint: string
        if (!is_null($icerik) && !is_string($icerik)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($icerik, true), gettype($icerik)), __LINE__);
        }
        if (is_null($icerik) || (is_array($icerik) && empty($icerik))) {
            unset($this->Icerik);
        } else {
            $this->Icerik = $icerik;
        }
        return $this;
    }
    /**
     * Get SeoAnahtarKelime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSeoAnahtarKelime()
    {
        return isset($this->SeoAnahtarKelime) ? $this->SeoAnahtarKelime : null;
    }
    /**
     * Set SeoAnahtarKelime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $seoAnahtarKelime
     * @return \StructType\KategoriDil
     */
    public function setSeoAnahtarKelime($seoAnahtarKelime = null)
    {
        // validation for constraint: string
        if (!is_null($seoAnahtarKelime) && !is_string($seoAnahtarKelime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($seoAnahtarKelime, true), gettype($seoAnahtarKelime)), __LINE__);
        }
        if (is_null($seoAnahtarKelime) || (is_array($seoAnahtarKelime) && empty($seoAnahtarKelime))) {
            unset($this->SeoAnahtarKelime);
        } else {
            $this->SeoAnahtarKelime = $seoAnahtarKelime;
        }
        return $this;
    }
    /**
     * Get SeoSayfaAciklama value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSeoSayfaAciklama()
    {
        return isset($this->SeoSayfaAciklama) ? $this->SeoSayfaAciklama : null;
    }
    /**
     * Set SeoSayfaAciklama value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $seoSayfaAciklama
     * @return \StructType\KategoriDil
     */
    public function setSeoSayfaAciklama($seoSayfaAciklama = null)
    {
        // validation for constraint: string
        if (!is_null($seoSayfaAciklama) && !is_string($seoSayfaAciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($seoSayfaAciklama, true), gettype($seoSayfaAciklama)), __LINE__);
        }
        if (is_null($seoSayfaAciklama) || (is_array($seoSayfaAciklama) && empty($seoSayfaAciklama))) {
            unset($this->SeoSayfaAciklama);
        } else {
            $this->SeoSayfaAciklama = $seoSayfaAciklama;
        }
        return $this;
    }
    /**
     * Get SeoSayfaBaslik value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSeoSayfaBaslik()
    {
        return isset($this->SeoSayfaBaslik) ? $this->SeoSayfaBaslik : null;
    }
    /**
     * Set SeoSayfaBaslik value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $seoSayfaBaslik
     * @return \StructType\KategoriDil
     */
    public function setSeoSayfaBaslik($seoSayfaBaslik = null)
    {
        // validation for constraint: string
        if (!is_null($seoSayfaBaslik) && !is_string($seoSayfaBaslik)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($seoSayfaBaslik, true), gettype($seoSayfaBaslik)), __LINE__);
        }
        if (is_null($seoSayfaBaslik) || (is_array($seoSayfaBaslik) && empty($seoSayfaBaslik))) {
            unset($this->SeoSayfaBaslik);
        } else {
            $this->SeoSayfaBaslik = $seoSayfaBaslik;
        }
        return $this;
    }
    /**
     * Get Tanim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTanim()
    {
        return isset($this->Tanim) ? $this->Tanim : null;
    }
    /**
     * Set Tanim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tanim
     * @return \StructType\KategoriDil
     */
    public function setTanim($tanim = null)
    {
        // validation for constraint: string
        if (!is_null($tanim) && !is_string($tanim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tanim, true), gettype($tanim)), __LINE__);
        }
        if (is_null($tanim) || (is_array($tanim) && empty($tanim))) {
            unset($this->Tanim);
        } else {
            $this->Tanim = $tanim;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KategoriDil
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
