<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaveParaBirimi StructType
 * @subpackage Structs
 */
class SaveParaBirimi extends AbstractStructBase
{
    /**
     * The UyeKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UyeKodu;
    /**
     * The parabirimi
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ParaBirimi
     */
    public $parabirimi;
    /**
     * Constructor method for SaveParaBirimi
     * @uses SaveParaBirimi::setUyeKodu()
     * @uses SaveParaBirimi::setParabirimi()
     * @param string $uyeKodu
     * @param \StructType\ParaBirimi $parabirimi
     */
    public function __construct($uyeKodu = null, \StructType\ParaBirimi $parabirimi = null)
    {
        $this
            ->setUyeKodu($uyeKodu)
            ->setParabirimi($parabirimi);
    }
    /**
     * Get UyeKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUyeKodu()
    {
        return isset($this->UyeKodu) ? $this->UyeKodu : null;
    }
    /**
     * Set UyeKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uyeKodu
     * @return \StructType\SaveParaBirimi
     */
    public function setUyeKodu($uyeKodu = null)
    {
        // validation for constraint: string
        if (!is_null($uyeKodu) && !is_string($uyeKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uyeKodu, true), gettype($uyeKodu)), __LINE__);
        }
        if (is_null($uyeKodu) || (is_array($uyeKodu) && empty($uyeKodu))) {
            unset($this->UyeKodu);
        } else {
            $this->UyeKodu = $uyeKodu;
        }
        return $this;
    }
    /**
     * Get parabirimi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ParaBirimi|null
     */
    public function getParabirimi()
    {
        return isset($this->parabirimi) ? $this->parabirimi : null;
    }
    /**
     * Set parabirimi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ParaBirimi $parabirimi
     * @return \StructType\SaveParaBirimi
     */
    public function setParabirimi(\StructType\ParaBirimi $parabirimi = null)
    {
        if (is_null($parabirimi) || (is_array($parabirimi) && empty($parabirimi))) {
            unset($this->parabirimi);
        } else {
            $this->parabirimi = $parabirimi;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SaveParaBirimi
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
