<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TakimUrunV2 StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TakimUrunV2
 * @subpackage Structs
 */
class TakimUrunV2 extends AbstractStructBase
{
    /**
     * The Adet
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Adet;
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Id;
    /**
     * The Secili
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Secili;
    /**
     * The Sira
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Sira;
    /**
     * The TakimUrunKartiId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $TakimUrunKartiId;
    /**
     * The TakimUrunKartiTedarikciKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TakimUrunKartiTedarikciKodu;
    /**
     * The UrunId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $UrunId;
    /**
     * The UrunKartiId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $UrunKartiId;
    /**
     * The UrunKartiTedarikciKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UrunKartiTedarikciKodu;
    /**
     * The UrunTedarikciKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UrunTedarikciKodu;
    /**
     * Constructor method for TakimUrunV2
     * @uses TakimUrunV2::setAdet()
     * @uses TakimUrunV2::setId()
     * @uses TakimUrunV2::setSecili()
     * @uses TakimUrunV2::setSira()
     * @uses TakimUrunV2::setTakimUrunKartiId()
     * @uses TakimUrunV2::setTakimUrunKartiTedarikciKodu()
     * @uses TakimUrunV2::setUrunId()
     * @uses TakimUrunV2::setUrunKartiId()
     * @uses TakimUrunV2::setUrunKartiTedarikciKodu()
     * @uses TakimUrunV2::setUrunTedarikciKodu()
     * @param float $adet
     * @param int $id
     * @param bool $secili
     * @param int $sira
     * @param int $takimUrunKartiId
     * @param string $takimUrunKartiTedarikciKodu
     * @param int $urunId
     * @param int $urunKartiId
     * @param string $urunKartiTedarikciKodu
     * @param string $urunTedarikciKodu
     */
    public function __construct($adet = null, $id = null, $secili = null, $sira = null, $takimUrunKartiId = null, $takimUrunKartiTedarikciKodu = null, $urunId = null, $urunKartiId = null, $urunKartiTedarikciKodu = null, $urunTedarikciKodu = null)
    {
        $this
            ->setAdet($adet)
            ->setId($id)
            ->setSecili($secili)
            ->setSira($sira)
            ->setTakimUrunKartiId($takimUrunKartiId)
            ->setTakimUrunKartiTedarikciKodu($takimUrunKartiTedarikciKodu)
            ->setUrunId($urunId)
            ->setUrunKartiId($urunKartiId)
            ->setUrunKartiTedarikciKodu($urunKartiTedarikciKodu)
            ->setUrunTedarikciKodu($urunTedarikciKodu);
    }
    /**
     * Get Adet value
     * @return float|null
     */
    public function getAdet()
    {
        return $this->Adet;
    }
    /**
     * Set Adet value
     * @param float $adet
     * @return \StructType\TakimUrunV2
     */
    public function setAdet($adet = null)
    {
        // validation for constraint: float
        if (!is_null($adet) && !(is_float($adet) || is_numeric($adet))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($adet, true), gettype($adet)), __LINE__);
        }
        $this->Adet = $adet;
        return $this;
    }
    /**
     * Get Id value
     * @return int|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \StructType\TakimUrunV2
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get Secili value
     * @return bool|null
     */
    public function getSecili()
    {
        return $this->Secili;
    }
    /**
     * Set Secili value
     * @param bool $secili
     * @return \StructType\TakimUrunV2
     */
    public function setSecili($secili = null)
    {
        // validation for constraint: boolean
        if (!is_null($secili) && !is_bool($secili)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($secili, true), gettype($secili)), __LINE__);
        }
        $this->Secili = $secili;
        return $this;
    }
    /**
     * Get Sira value
     * @return int|null
     */
    public function getSira()
    {
        return $this->Sira;
    }
    /**
     * Set Sira value
     * @param int $sira
     * @return \StructType\TakimUrunV2
     */
    public function setSira($sira = null)
    {
        // validation for constraint: int
        if (!is_null($sira) && !(is_int($sira) || ctype_digit($sira))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sira, true), gettype($sira)), __LINE__);
        }
        $this->Sira = $sira;
        return $this;
    }
    /**
     * Get TakimUrunKartiId value
     * @return int|null
     */
    public function getTakimUrunKartiId()
    {
        return $this->TakimUrunKartiId;
    }
    /**
     * Set TakimUrunKartiId value
     * @param int $takimUrunKartiId
     * @return \StructType\TakimUrunV2
     */
    public function setTakimUrunKartiId($takimUrunKartiId = null)
    {
        // validation for constraint: int
        if (!is_null($takimUrunKartiId) && !(is_int($takimUrunKartiId) || ctype_digit($takimUrunKartiId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($takimUrunKartiId, true), gettype($takimUrunKartiId)), __LINE__);
        }
        $this->TakimUrunKartiId = $takimUrunKartiId;
        return $this;
    }
    /**
     * Get TakimUrunKartiTedarikciKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTakimUrunKartiTedarikciKodu()
    {
        return isset($this->TakimUrunKartiTedarikciKodu) ? $this->TakimUrunKartiTedarikciKodu : null;
    }
    /**
     * Set TakimUrunKartiTedarikciKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $takimUrunKartiTedarikciKodu
     * @return \StructType\TakimUrunV2
     */
    public function setTakimUrunKartiTedarikciKodu($takimUrunKartiTedarikciKodu = null)
    {
        // validation for constraint: string
        if (!is_null($takimUrunKartiTedarikciKodu) && !is_string($takimUrunKartiTedarikciKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($takimUrunKartiTedarikciKodu, true), gettype($takimUrunKartiTedarikciKodu)), __LINE__);
        }
        if (is_null($takimUrunKartiTedarikciKodu) || (is_array($takimUrunKartiTedarikciKodu) && empty($takimUrunKartiTedarikciKodu))) {
            unset($this->TakimUrunKartiTedarikciKodu);
        } else {
            $this->TakimUrunKartiTedarikciKodu = $takimUrunKartiTedarikciKodu;
        }
        return $this;
    }
    /**
     * Get UrunId value
     * @return int|null
     */
    public function getUrunId()
    {
        return $this->UrunId;
    }
    /**
     * Set UrunId value
     * @param int $urunId
     * @return \StructType\TakimUrunV2
     */
    public function setUrunId($urunId = null)
    {
        // validation for constraint: int
        if (!is_null($urunId) && !(is_int($urunId) || ctype_digit($urunId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($urunId, true), gettype($urunId)), __LINE__);
        }
        $this->UrunId = $urunId;
        return $this;
    }
    /**
     * Get UrunKartiId value
     * @return int|null
     */
    public function getUrunKartiId()
    {
        return $this->UrunKartiId;
    }
    /**
     * Set UrunKartiId value
     * @param int $urunKartiId
     * @return \StructType\TakimUrunV2
     */
    public function setUrunKartiId($urunKartiId = null)
    {
        // validation for constraint: int
        if (!is_null($urunKartiId) && !(is_int($urunKartiId) || ctype_digit($urunKartiId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($urunKartiId, true), gettype($urunKartiId)), __LINE__);
        }
        $this->UrunKartiId = $urunKartiId;
        return $this;
    }
    /**
     * Get UrunKartiTedarikciKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUrunKartiTedarikciKodu()
    {
        return isset($this->UrunKartiTedarikciKodu) ? $this->UrunKartiTedarikciKodu : null;
    }
    /**
     * Set UrunKartiTedarikciKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $urunKartiTedarikciKodu
     * @return \StructType\TakimUrunV2
     */
    public function setUrunKartiTedarikciKodu($urunKartiTedarikciKodu = null)
    {
        // validation for constraint: string
        if (!is_null($urunKartiTedarikciKodu) && !is_string($urunKartiTedarikciKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urunKartiTedarikciKodu, true), gettype($urunKartiTedarikciKodu)), __LINE__);
        }
        if (is_null($urunKartiTedarikciKodu) || (is_array($urunKartiTedarikciKodu) && empty($urunKartiTedarikciKodu))) {
            unset($this->UrunKartiTedarikciKodu);
        } else {
            $this->UrunKartiTedarikciKodu = $urunKartiTedarikciKodu;
        }
        return $this;
    }
    /**
     * Get UrunTedarikciKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUrunTedarikciKodu()
    {
        return isset($this->UrunTedarikciKodu) ? $this->UrunTedarikciKodu : null;
    }
    /**
     * Set UrunTedarikciKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $urunTedarikciKodu
     * @return \StructType\TakimUrunV2
     */
    public function setUrunTedarikciKodu($urunTedarikciKodu = null)
    {
        // validation for constraint: string
        if (!is_null($urunTedarikciKodu) && !is_string($urunTedarikciKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urunTedarikciKodu, true), gettype($urunTedarikciKodu)), __LINE__);
        }
        if (is_null($urunTedarikciKodu) || (is_array($urunTedarikciKodu) && empty($urunTedarikciKodu))) {
            unset($this->UrunTedarikciKodu);
        } else {
            $this->UrunTedarikciKodu = $urunTedarikciKodu;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TakimUrunV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
